#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct UnitConversionSeriesNode {
    #[builder(custom(type = super::NumericSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeriesNode>,
    #[serde(rename = "inputUnit")]
    input_unit: super::super::super::super::units::api::UnitSymbol,
    #[serde(rename = "outputUnit")]
    output_unit: super::super::super::super::units::api::UnitSymbol,
}
impl UnitConversionSeriesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        input: super::NumericSeriesNode,
        input_unit: super::super::super::super::units::api::UnitSymbol,
        output_unit: super::super::super::super::units::api::UnitSymbol,
    ) -> Self {
        Self::builder()
            .input(input)
            .input_unit(input_unit)
            .output_unit(output_unit)
            .build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn input_unit(&self) -> &super::super::super::super::units::api::UnitSymbol {
        &self.input_unit
    }
    #[inline]
    pub fn output_unit(&self) -> &super::super::super::super::units::api::UnitSymbol {
        &self.output_unit
    }
}
